import * as wasm from './cross_rust_wasm_bg.wasm';

const lTextDecoder = typeof TextDecoder === 'undefined' ? (0, module.require)('util').TextDecoder : TextDecoder;

let cachedTextDecoder = new lTextDecoder('utf-8', { ignoreBOM: true, fatal: true });

cachedTextDecoder.decode();

let cachedUint8Memory0 = new Uint8Array();

function getUint8Memory0() {
    if (cachedUint8Memory0.byteLength === 0) {
        cachedUint8Memory0 = new Uint8Array(wasm.memory.buffer);
    }
    return cachedUint8Memory0;
}

function getStringFromWasm0(ptr, len) {
    return cachedTextDecoder.decode(getUint8Memory0().subarray(ptr, ptr + len));
}
/**
*/
export function greet() {
    wasm.greet();
}

/**
* @param {number} left
* @param {number} right
* @returns {number}
*/
export function add(left, right) {
    const ret = wasm.add(left, right);
    return ret >>> 0;
}

/**
* @param {number} x
* @param {number} y
* @param {number} z
* @param {number} w
* @returns {PubQuaternion}
*/
export function gen_quaternion(x, y, z, w) {
    const ret = wasm.gen_quaternion(x, y, z, w);
    return PubQuaternion.__wrap(ret);
}

/**
* @param {number} x
* @param {number} y
* @param {number} z
* @param {number} w
* @returns {number}
*/
export function gen_quaternion_str(x, y, z, w) {
    const ret = wasm.gen_quaternion_str(x, y, z, w);
    return ret;
}

/**
* @param {number} s
*/
export function gen_quaternion_str_free(s) {
    wasm.gen_obj_info_str_free(s);
}

/**
* @param {number} name
* @param {number} age
* @param {number} desc
* @returns {number}
*/
export function gen_obj_info_str(name, age, desc) {
    const ret = wasm.gen_obj_info_str(name, age, desc);
    return ret;
}

/**
* @param {number} s
*/
export function gen_obj_info_str_free(s) {
    wasm.gen_obj_info_str_free(s);
}

/**
* @param {number} name
* @param {number} age
* @param {number} desc
* @returns {number}
*/
export function gen_obj_info(name, age, desc) {
    const ret = wasm.gen_obj_info(name, age, desc);
    return ret;
}

/**
* @param {number} ptr
*/
export function gen_obj_info_free(ptr) {
    wasm.gen_obj_info_free(ptr);
}

/**
*/
export class PubObjInfo {

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_pubobjinfo_free(ptr);
    }
    /**
    * @returns {number}
    */
    get name() {
        const ret = wasm.__wbg_get_pubobjinfo_name(this.ptr);
        return ret;
    }
    /**
    * @param {number} arg0
    */
    set name(arg0) {
        wasm.__wbg_set_pubobjinfo_name(this.ptr, arg0);
    }
    /**
    * @returns {number}
    */
    get age() {
        const ret = wasm.__wbg_get_pubobjinfo_age(this.ptr);
        return ret;
    }
    /**
    * @param {number} arg0
    */
    set age(arg0) {
        wasm.__wbg_set_pubobjinfo_age(this.ptr, arg0);
    }
    /**
    * @returns {number}
    */
    get desc() {
        const ret = wasm.__wbg_get_pubobjinfo_desc(this.ptr);
        return ret;
    }
    /**
    * @param {number} arg0
    */
    set desc(arg0) {
        wasm.__wbg_set_pubobjinfo_desc(this.ptr, arg0);
    }
}
/**
*/
export class PubQuaternion {

    static __wrap(ptr) {
        const obj = Object.create(PubQuaternion.prototype);
        obj.ptr = ptr;

        return obj;
    }

    __destroy_into_raw() {
        const ptr = this.ptr;
        this.ptr = 0;

        return ptr;
    }

    free() {
        const ptr = this.__destroy_into_raw();
        wasm.__wbg_pubquaternion_free(ptr);
    }
    /**
    * @returns {number}
    */
    get x() {
        const ret = wasm.__wbg_get_pubquaternion_x(this.ptr);
        return ret;
    }
    /**
    * @param {number} arg0
    */
    set x(arg0) {
        wasm.__wbg_set_pubquaternion_x(this.ptr, arg0);
    }
    /**
    * @returns {number}
    */
    get y() {
        const ret = wasm.__wbg_get_pubobjinfo_age(this.ptr);
        return ret;
    }
    /**
    * @param {number} arg0
    */
    set y(arg0) {
        wasm.__wbg_set_pubobjinfo_age(this.ptr, arg0);
    }
    /**
    * @returns {number}
    */
    get z() {
        const ret = wasm.__wbg_get_pubquaternion_z(this.ptr);
        return ret;
    }
    /**
    * @param {number} arg0
    */
    set z(arg0) {
        wasm.__wbg_set_pubquaternion_z(this.ptr, arg0);
    }
    /**
    * @returns {number}
    */
    get w() {
        const ret = wasm.__wbg_get_pubquaternion_w(this.ptr);
        return ret;
    }
    /**
    * @param {number} arg0
    */
    set w(arg0) {
        wasm.__wbg_set_pubquaternion_w(this.ptr, arg0);
    }
}

export function __wbg_alert_5ac93de0e41a7431(arg0, arg1) {
    alert(getStringFromWasm0(arg0, arg1));
};

export function __wbindgen_throw(arg0, arg1) {
    throw new Error(getStringFromWasm0(arg0, arg1));
};

